package com.inuker.bluetooth.dialog;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.res.Configuration;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

import com.inuker.bluetooth.R;
import com.inuker.bluetooth.helper.Utils;

/**
 * 通知密码
 * */
public class DeviceLinkSleepDialogHelper {

    private static AlertDialog alertDialog;
    private static String type="";


    public static void showDialog(Activity activity, final String type, final ClickListener clickListener) {

        View contentView = LayoutInflater.from(activity).inflate(R.layout.main_dev_lin_wifi_dialog, null);
        AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        builder.setView(contentView);
        LinearLayout layout = (LinearLayout) contentView.findViewById(R.id.dev_lin_wifi_ll_net_config_view);
         final EditText network2_ip = (EditText) contentView.findViewById(R.id.dev_lin_wifi_ip);
         final EditText network2_wg = (EditText) contentView.findViewById(R.id.dev_lin_wifi_wg);
        Button network2_cancel_button = (Button) contentView.findViewById(R.id.dev_lin_wifi_cancel_button);
        Button network2_determine_button = (Button) contentView.findViewById(R.id.dev_lin_wifi_determine_button);

        layout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                try {
                    Utils.hideInputKeyboard(alertDialog.getWindow().getDecorView().getWindowToken());
                } catch (Exception e) {
                    //
                }
            }
        });

        network2_cancel_button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });

        network2_determine_button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (alertDialog != null && alertDialog.isShowing()) {
                    alertDialog.dismiss();
                    String name = network2_ip.getText().toString();
                    String Password = network2_wg.getText().toString();
                    if (!name.equals("")&& !Password.equals("")){
                        clickListener.onClick(name,Password,type);
                    }

                }
            }
        });

        alertDialog = builder.create();
        alertDialog.setCanceledOnTouchOutside(false);
        alertDialog.setCancelable(false);
        alertDialog.show();
//        DisplayMetrics metrics = new DisplayMetrics();
//        activity.getWindowManager().getDefaultDisplay().getMetrics(metrics);
//        int screenWidth = metrics.widthPixels;
//        int orientation = activity.getResources().getConfiguration().orientation;
//        if (orientation == Configuration.ORIENTATION_PORTRAIT && screenWidth>600) {
//            try {
//                Window window = alertDialog.getWindow();
//                WindowManager.LayoutParams lp = window.getAttributes();
//                lp.width = 800;
//                lp.height = 650;
//                lp.gravity = Gravity.CENTER;
//                window.setAttributes(lp);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }

    }

    public interface ClickListener{
        void onClick(String name, String Password,String type);
    }
    public static  void dismissCallDialog() {
        if (alertDialog != null) {
            alertDialog.dismiss();
        }
    }
}
