package com.inuker.bluetooth.helper;

import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;
import android.view.inputmethod.InputMethodManager;
import com.inuker.bluetooth.MyApplication;


public class Utils {

    public static final int STATUS_BAR_DISABLE_HOME = 0x00200000;
    public static final int STATUS_BAR_DISABLE_BACK = 0x00400000;
    public static final int STATUS_BAR_DISABLE_RECENT = 0x01000000;
    public static final int STATUS_BAR_DISABLE_EXPAND = 0x00010000;//4.2以上的整形标识
    public static final int STATUS_BAR_DISABLE_NONE = 0x00000000;//取消StatusBar所有disable属性，即还原到最最原始状态


    //是否隐藏系统栏
    public static void hideStatusBarDch(Context context, boolean hide) {
        Log.d("StatusBar", "toggleStatusBar: hide ===== " + hide);
        Intent intent = new Intent();
        intent.setAction("control.nav.hide");//虚拟按键
        if (hide) {
            intent.putExtra("hide", "1");//关闭
        } else {
            intent.putExtra("hide", "0");//开启
        }
        context.sendBroadcast(intent);
    }

    //是否隐藏系统栏
    public static void hideStatusBarYld(Context context, boolean hide) {
        Intent intent = new Intent();
        if (hide) {
            intent.setAction("com.elclcd.hidebar");
        } else {
            intent.setAction("com.elclcd.unhidebar");
        }
        context.sendBroadcast(intent);
    }

    //隐藏软键盘
    public static void hideInputKeyboard(IBinder token) {
        try {
            Log.d("keyboard", "hide input keyboard ===== ");
            InputMethodManager mInputKeyBoard = (InputMethodManager) MyApplication.getInstance().getSystemService(Context.INPUT_METHOD_SERVICE);
            mInputKeyBoard.hideSoftInputFromWindow(token, 0);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
