package com.inuker.bluetooth.sleep;


import android.os.Build;
import android.util.Log;

import com.clj.fastble.utils.HexUtil;

import java.util.Arrays;


public class SleepDataParse {

    private final static String TAG = "SleepDataParse";

    public static final int ACK_REQUIRED = 0x01;
    public static final int NO_ACK_REQUIRED = 0x00;

    private int dataLength; //数据长度
    private int ackRequired;
    private int messageSequence;
    private int commandType;
    private byte[] data;


    //床垫数据 蓝牙设置网络
    public static byte[] parseValue4(String name, String Password) {
        //名称以及密码以双引号包含，中间加逗号
        String str = BluetoothUtil.strTo16(name +Password);
        byte[] data =  HexUtil.hexStringToBytes(str);
        Log.d(TAG, "发送配网数据: " + HexUtil.formatHexString(data, false));
        byte[] dataLength = HexUtil.hexStringToBytes(BluetoothUtil.intToTwoBytesHexString( data.length+9));
        SleepSetwifiDataParse dataPacket = new SleepSetwifiDataParse(dataLength, name, Password);
        // 将 DataPacket 对象转换为字节数组
        byte[] byteArray = dataPacket.toByteArray();
        return byteArray;
    }

    //跌倒雷达 数据 蓝牙设置网络
    public static byte[] parseValue5(  int lenValue , byte[] fullData, int packetIndex) {
        int start = packetIndex * 18;
        int end = Math.min(fullData.length, start + 18);
        byte[] dataPart = Arrays.copyOfRange(fullData, start, end);
        Log.d(TAG, "发送配网数据: " + HexUtil.formatHexString(dataPart, false));
        byte[] packet = new byte[1 + 1 + dataPart.length];  // Head + Len + Data
        packet[0] = (byte) 0xA7;  // 起始位固定为 0xA7
        packet[1] = (byte) lenValue;  // Len 字段

        System.arraycopy(dataPart, 0, packet, 2, dataPart.length);  // 复制数据部分到数据包
//        LdSetwifiDataParse dataPacket = new LdSetwifiDataParse(lenValue, name, Password);
        // 将 DataPacket 对象转换为字节数组
//        byte[] byteArray = dataPacket.toByteArray();
        return packet;
    }

    private static byte[] concatByteArrays(byte[] a, byte[] b) {
        byte[] result = new byte[a.length + b.length];
        System.arraycopy(a, 0, result, 0, a.length);
        System.arraycopy(b, 0, result, a.length, b.length);
        return result;
    }


    public interface OnDataCallback {
        void onData(String data);
    }
}
